// override `replaceContent()` method of editor proxy
// to provide desired output for back-end app
objcEmmetEditor.replaceContent = function(value, start, end, noIndent) {
	var content = this.getContent();
	var caretPos = this.getCaretPos();

	if (_.isUndefined(end)) 
		end = _.isUndefined(start) ? content.length : start;
	if (_.isUndefined(start)) start = 0;
	
	value = tmUpdateTabStops(value);
	this.getContext().replaceContentWithValueFromToWithoutIndentation(value, start, end, !!noIndent);
};

function tmUpdateTabStops(value) {
	var base = 1000;
	var zeroBase = 0;
	var lastZero = null;
	var range = require('range');
	var ts = require('tabStops');
    
    //log("before: " + value);
    
	var tabstopOptions = {
    tabstop: function(data) {
        var group = parseInt(data.group, 10);
        var isZero = group === 0;
        if (isZero)
            group = ++zeroBase;
        else
            group += base;
        
        var placeholder = data.placeholder;
        if (placeholder) {
            // recursively update nested tabstops
            placeholder = ts.processText(placeholder, tabstopOptions);
        }
        
        var result = '${' + group + (placeholder ? ':' + placeholder : '') + '}';
        
        if (isZero) {
            lastZero = range.create(data.start, result);
        }
        
        return result
    },
    escape: function(ch) {
        if (ch == '$') {
            return '\\$';
        }
        
        if (ch == '\\') {
            return '\\\\';
        }
        
        return ch;
    }
	};
    
	value = ts.processText(value, tabstopOptions);
    
    if (lastZero) {
		value = require('utils').replaceSubstring(value, '$0', lastZero);
	}
    
    //log("after: " + value);
	
	return value;
}